--This free script lets you quickly change PRS controllers
--of any number selected objects using a reference node or 
--a set of custom controllers. 
--If you have any questions, suggestions or improvements,
--please email me: bobo@email.archlab.tuwien.ac.at
--Or visit Boboland under http://gfxcentral.com/bobo/


utility controller_center "ControllerCenter"
(
group "About..."
(
label aboutcm01 "ControllerCenter"
label aboutcm02 "Beta 0.1"
label aboutcm03 "10/21/98 - Copyright 1998"
label aboutcm04 "by Bobo's Rendert**ls"
label aboutcm05 "http://gfxcentral.com/bobo/" 
)
group "Reference Node"
(
pickbutton get_ref "Pick Reference Node" width:140
checkbutton use_ref "Use Reference Node" checked:false enabled:false width:140 highlightcolor:green
label ref_node_pos "Position:None" align:#center
label ref_node_rot "Rotation:None" align:#center
label ref_node_scale "Scale:None" align:#center
radiobuttons clone_inst "" labels:#("Copy","Instance")
)
group "Set Custom Controllers"
(
checkbutton use_user "Use Custom" checked:true enabled:false width:140 highlightcolor:green

label u_p_l "Pos.:" across:2 align:#left
dropdownlist user_pos items:#("Attachment","Audio","Bezier","Linear","Noise","Path","Expression","List","MotionCapture","Script","Surface","TCB","XYZ") selection:3 width:100 align:#right

label u_r_l "Rot.:" across:2 align:#left
dropdownlist user_rot items:#("Audio","EulerXYZ","Linear","Noise","List","MotionCapture","Script","Smooth","TCB") selection:9 width:100 align:#right


label u_s_l "Scale:" across:2 align:#left
dropdownlist user_scale items:#("Audio","Bezier","Linear","Noise","Expression","List","MotionCapture","Script","TCB") selection:2 width:100 align:#right

)

group "Set Controller"
(
checkbox set_pos "Pos." checked:true across:3
checkbox set_rot "Rot." checked:true
checkbox set_scale "Scale" checked:true

radiobuttons unique_yes "" labels:#("Unique","Refs.")
)

button set_controllers "SET CONTROLLERS" width:140 height:30


on use_user changed state do
(
if use_ref.enabled == true then
	(
	if state then use_ref.checked=false else use_ref.checked=true
	)
)

on use_ref changed state do
(
if state then use_user.checked=false else use_user.checked=true 
)

on get_ref picked obj do
(
get_ref.text = obj.name
ref_node = obj
use_ref.enabled = true
use_ref.checked = true
use_user.enabled = true
use_user.checked = false
ref_pos = ref_node.pos.controller
ref_rot = ref_node.rotation.controller
ref_scale = ref_node.scale.controller
txt = ref_pos as string
ddpos = (findstring txt ":") 
txt = substring txt (ddpos+1) (txt.count-ddpos)
ref_node_pos.text = "Position:"+txt 


txt = ref_rot as string
ddpos = (findstring txt ":") 
txt = substring txt (ddpos+1) (txt.count-ddpos)
ref_node_rot.text = "Rotation:"+txt 



txt = ref_scale as string
ddpos = (findstring txt ":") 
txt = substring txt (ddpos+1) (txt.count-ddpos)
ref_node_scale.text = "Scale:"+txt 
)

on set_controllers pressed do
(
node_array = for obj in selection collect obj
for i = 1 to node_array.count do
	(
	
get_controllers = false	
if unique_yes.state == 2 and i == 1 then get_controllers = true
if unique_yes.state == 1 then get_controllers = true

if get_controllers then
(
if use_ref.checked and use_ref.enabled then
	(
		if clone_inst.state == 2 then 
		(
		ref_pos = ref_node.pos.controller
		ref_rot = ref_node.rotation.controller
		ref_scale = ref_node.scale.controller
		)
		else
		(
		txt = ref_node.pos.controller as string
		ddpos = (findstring txt ":") 
		txt = substring txt (ddpos+1) (txt.count-ddpos)
		ref_pos_text = txt + " ()"
		
		txt = ref_node.rotation.controller as string
		ddpos = (findstring txt ":") 
		txt = substring txt (ddpos+1) (txt.count-ddpos)
		ref_rot_text = txt + " ()"
		
		txt = ref_node.scale.controller as string
		ddpos = (findstring txt ":") 
		txt = substring txt (ddpos+1) (txt.count-ddpos)
		ref_scale_text = txt + " ()"
		
		ref_pos = execute ref_pos_text 
		ref_rot = execute ref_rot_text 
		ref_scale = execute ref_scale_text 
		)--end else
	)--end if ref
	else
	(
	case user_pos.selection of
		(
		1: ref_pos = Attachment ()
		2: ref_pos = AudioPosition ()
		3: ref_pos = Bezier_Position ()
		4: ref_pos = Linear_Position ()
		5: ref_pos = Noise_Position ()
		6: ref_pos = Path ()
		7: ref_pos = Position_Expression ()
		8: ref_pos = Position_List ()
		9: ref_pos = Position_Motion_Capture()
		10: ref_pos = Position_Script ()
		11: ref_pos = Surface ()
		12: ref_pos = TCB_Position ()
		13: ref_pos = Position_XYZ ()
		)--end case
		
		case user_rot.selection of
		(
		1: ref_rot = AudioRotation ()
		2: ref_rot = Euler_XYZ ()
		3: ref_rot = Linear_Rotation ()
		4: ref_rot = Noise_Rotation ()
		5: ref_rot = Rotation_List ()
		6: ref_rot = Rotation_Motion_Capture()
		7: ref_rot = Rotation_Script ()
		8: ref_rot = Bezier_Rotation ()
		9: ref_rot = TCB_Rotation ()		
		)--end case
		
		
		case user_scale.selection of
		(
		1: ref_scale = AudioScale ()
		2: ref_scale = Bezier_Scale ()
		3: ref_scale = Linear_Scale ()
		4: ref_scale = Noise_Scale ()
		5: ref_scale = Scale_Expression ()
		6: ref_scale = Rotation_List ()
		7: ref_scale = Rotation_Motion_Capture()
		8: ref_scale = Rotation_Script ()
		9: ref_scale = TCB_Scale ()
		)--end case
		
	)--end else ref
)--end if get controllers


	if set_pos.checked then node_array[i].pos.controller = ref_pos
	if set_rot.checked then node_array[i].rotation.controller = ref_rot
	if set_scale.checked then node_array[i].scale.controller = ref_scale
	)--end i loop

)--end on set

)--end util